//
//  AEServer.m
//  server
//
//  Created by howiieque on 4/30/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "AEServer.h"

@interface AEServer ()

- (void)connectionDidDie:(NSNotification *)aNotification;

@end

@implementation AEServer

- (oneway void)addMessageClient:(id)client {
	[listOfClients addObject:client];
	NSLog(@"Did added %@", client);
}

- (BOOL)removeMessageClient:(id)client {
	[listOfClients removeObject:client];
	NSLog(@"Did removed %@", client);
	return YES;
}

- (oneway void)broadcastMessage:(NSString *)string {
	[listOfClients makeObjectsPerformSelector:@selector(appendMessage:) withObject:string];
}

- (void)connectionDidDie:(NSNotification *)aNotification {
	NSConnection *deadConnection = [aNotification object];
	for (int i=[listOfClients count]-1; i>=0; i--) {
		id currentClient=[listOfClients objectAtIndex:i];
		@try {
			if([currentClient respondsToSelector:@selector(connectionForProxy)]) {
				if([currentClient connectionForProxy]==deadConnection) {
					[listOfClients removeObjectAtIndex:i];
					NSLog(@"Removed dead client.");
				}
			}
		}
		@catch (NSException * e) {
			[listOfClients removeObjectAtIndex:i];
			NSLog(@"error: %@. Removed dead client.", [e reason]);
		}
	}
}

- (id)init {
    if (self = [super init]) {
        listOfClients = [[NSMutableArray alloc] init];
    }
    return self;
}

- (void)dealloc {
	[listOfClients release];
	listOfClients=nil;
	[super dealloc];
}

@end
